//+------------------------------------------------------------------+
//|                                                 SwingTrader2.mq4 |
//|                                      Copyright  2007, Bo_Bokus. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Bo_Bokus."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Black
//---- input parameters
extern int SwingPeriod=12;
//---- buffers
double SwingBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- indicator line
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,SwingBuffer);
//---- name for DataWindow and indicator subwindow label
   short_name="SwingTrader2("+SwingPeriod+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
//----
   SetIndexDrawBegin(0,SwingPeriod);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| SwingTrader                                                      |
//+------------------------------------------------------------------+
int start()
  {
   int i,counted_bars=IndicatorCounted();
//----
   if(Bars<=SwingPeriod) return(0);
//---- initial zero
   if(counted_bars<1)
      for(i=1;i<=SwingPeriod;i++) SwingBuffer[Bars-i]=0.0;
//----
   i=Bars-SwingPeriod-1;
   if(counted_bars>=SwingPeriod) i=Bars-counted_bars-1;
   while(i>=0)
     {
      SwingBuffer[i]=Close[i]*100/Close[i+SwingPeriod];
      i--;
     }
   return(0);
  }
//+------------------------------------------------------------------+